{   alsmplayer Copyright (c) 2010 by Alexandre Minoshi
    
    version see in tmplayer.create procedure  19/09/2010 
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    
    minoshi@yandex.ru
    
    Support Analog TV by Coyot.RusH
}

unit alsmplayer;
{$ifdef FPC}{$mode objfpc}{$h+}{$endif}
interface

uses
 msestrings, mseterminal, classes,
 mseclasses, sysutils, msetimer,
 msewindowwidget, msegui,
 mseprocess;
  
type TStatusEvent = procedure(const Sender : TObject; 
                              currentstatus : string;
                              position, length : integer)
                              of object; 
                            
type TStartPlayEvent = procedure(const Sender :TObject; 
                              videoW,videoH, volume : integer) 
                              of object; 

type TchangeVolumeEvent = procedure(const Sender :TObject; volume: integer) 
                              of object; 

type TDebugMessageEvent = procedure(const Sender :TObject; msg : AnsiString) 
                              of object; 

//type tplaymode=(__cd,__dvd,__dvb,__tv,__file,__http,__rtsp); <=original by coyot.rush
type tplaymode=(__cd,__dvd,__dvb,__tv,__file,__inet);                              

type tvideoresolution = record 
       x : integer;
       y : integer;
     end; 

type tCurrentTrackInfo = record
       filename         : msestring;
       videoresolution  : tvideoresolution;
       (* to be continued ... *)
     end; 
 

{ TV }
type tvnorm=(NTSC,NTSC_M,NTSC_M_JP,NTSC_M_KR,PAL,PAL_BG,
		PAL_H,PAL_I,PAL_DK,PAL_M,PAL_N,PAL_Nc,PAL_60,SECAM,SECAM_B,
		SECAM_G,SECAM_H,SECAM_DK,SECAM_L,SECAM_Lc);

type TvCannelName=(
		Ch_R1  ,Ch_R2  ,Ch_R3  ,Ch_R4  ,Ch_R5  ,Ch_R6  ,Ch_R7  ,Ch_R8  ,Ch_R9  ,Ch_R10 ,
		Ch_R11 ,Ch_R12 ,Ch_SR1 ,Ch_SR2 ,Ch_SR3 ,Ch_SR4 ,Ch_SR5 ,Ch_SR6 ,Ch_SR7 ,Ch_SR8 ,Ch_SR11 ,
		Ch_SR12,Ch_SR13,Ch_SR14,Ch_SR15,Ch_SR16,Ch_SR17,Ch_SR18,Ch_SR19,Ch_K1  ,Ch_K2  ,Ch_K3 ,
		Ch_K4  ,Ch_K5  ,Ch_K6  ,Ch_K7  ,Ch_K8  ,Ch_K9  ,Ch_K10 ,Ch_K11 ,Ch_K12 ,Ch_K21 ,Ch_K22 ,Ch_K23 ,
		Ch_K24 ,Ch_K25 ,Ch_K26 ,Ch_K27 ,Ch_K28 ,Ch_K29 ,Ch_K30 ,Ch_K31 ,Ch_K32 ,Ch_K33 ,Ch_K34 ,
		Ch_K35 ,Ch_K36 ,Ch_K37 ,Ch_K38 ,Ch_K39 ,Ch_K40 ,Ch_K41 ,Ch_K42 ,Ch_K43 ,Ch_K44 ,Ch_K45 ,Ch_K46 ,
		Ch_K47 ,Ch_K48 ,Ch_K49 ,Ch_K50 ,Ch_K51 ,Ch_K52 ,Ch_K53 ,Ch_K54 ,Ch_K55 ,Ch_K56 ,Ch_K57 ,Ch_K58 ,
		Ch_K59 ,Ch_K60 ,Ch_K61 ,Ch_K62 ,Ch_K63 ,Ch_K64 ,Ch_K65 ,Ch_K66 ,Ch_K67 ,Ch_K68 ,Ch_K69 ,Ch_S01 ,
		Ch_S02 ,Ch_S03 ,Ch_S1  ,Ch_S2  ,Ch_S3  ,Ch_S4  ,Ch_S5  ,Ch_S6  ,Ch_S7  ,Ch_S8  ,Ch_S9  ,Ch_S10 ,Ch_S11 ,
		Ch_S12 ,Ch_S13 ,Ch_S14 ,Ch_S15 ,Ch_S16 ,Ch_S17 ,Ch_S18 ,Ch_S19 ,Ch_S20 ,Ch_S21 ,Ch_S22 ,Ch_S23 ,
		Ch_S24 ,Ch_S25 ,Ch_S26 ,Ch_S27 ,Ch_S28 ,Ch_S29 ,Ch_S30 ,Ch_S31 ,Ch_S32 ,Ch_S33 ,Ch_S34 ,Ch_S35 ,
		Ch_S36 ,Ch_S37 ,Ch_S38 ,Ch_S39 ,Ch_S40 ,Ch_S41 );

const
tvCannelNameStr:array [TVCannelName] of String  =(
		'R1'   ,'R2'   ,'R3'   ,'R4'   ,'R5'   ,'R6'   ,'R7'   ,'R8'   ,'R9' ,'R10',
		'R11'  ,'R12'  ,'SR1'  ,'SR2'  ,'SR3'  ,'SR4'  ,'SR5'  ,'SR6'  ,'SR7'  ,'SR8'   ,'SR11'  ,
		'SR12' ,'SR13' ,'SR14' ,'SR15' ,'SR16' ,'SR17' ,'SR18' ,'SR19' ,'K1'   ,'K2'   ,'K3'  ,
		'K4'   ,'K5'   ,'K6'   ,'K7'   ,'K8'   ,'K9'   ,'K10'  ,'K11'  ,'K12'  ,'K21'  ,'K22'  ,'K23'  ,
		'K24'  ,'K25'  ,'K26'  ,'K27'  ,'K28'  ,'K29'  ,'K30'  ,'K31'  ,'K32'  ,'K33'  ,'K34'  ,
		'K35'  ,'K36'  ,'K37'  ,'K38'  ,'K39'  ,'K40'  ,'K41'  ,'K42'  ,'K43'  ,'K44'  ,'K45'  ,'K46'  ,
		'K47'  ,'K48'  ,'K49'  ,'K50'  ,'K51'  ,'K52'  ,'K53'  ,'K54'  ,'K55'  ,'K56'  ,'K57'  ,'K58'  ,
		'K59'  ,'K60'  ,'K61'  ,'K62'  ,'K63'  ,'K64'  ,'K65'  ,'K66'  ,'K67'  ,'K68'  ,'K69'  ,'S01'  ,
		'S02'  ,'S03'  ,'S1'   ,'S2'   ,'S3'   ,'S4'   ,'S5'   ,'S6'   ,'S7'   ,'S8'   ,'S9'   ,'S10'  ,'S11'  ,
		'S12'  ,'S13'  ,'S14'  ,'S15'  ,'S16'  ,'S17'  ,'S18'  ,'S19'  ,'S20'  ,'S21'  ,'S22'  ,'S23'  ,
		'S24'  ,'S25'  ,'S26'  ,'S27'  ,'S28'  ,'S29'  ,'S30'  ,'S31'  ,'S32'  ,'S33'  ,'S34'  ,'S35'  ,
		'S36'  ,'S37'  ,'S38'  ,'S39'  ,'S40'  ,'S41');

TvStr : array [tvnorm] of String [20] =(
		'NTSC','NTSC-M','NTSC-M-JP','NTSC-M-KR','PAL','PAL-BG',
		'PAL-H','PAL-I','PAL-DK','PAL-M','PAL-N','PAL-Nc','PAL-60','SECAM','SECAM-B',
		'SECAM-G','SECAM-H','SECAM-DK','SECAM-L','SECAM-Lc');


type PTVData = ^TTVData;

	TTVData = record
		Norm:tvnorm;
		Freq: integer;
		Name:msestring;
	end;

{ TTVDataList }

TTVDataList = class
 private
   FTVList: TList; // хранилище данных
 public
   constructor Create;
   destructor Destroy; override;
   function AddItem(Item: TTVData): Integer;
   procedure RemoveItem(ItemIndex: Integer);
   function GetData(Idx: integer): TTVData;
   procedure SetData(IDx:integer;Data:TTvdata);
   function Count: integer;
   procedure Exchange(idx1, idx2: integer);
end;
 
(* TMPLAYER CLASS *) 
type tmplayer = class
 private  
  ftimer		: ttimer;
  fterm         : tterminal;
  fdisplay      : tcustomwindowwidget;
  fmplayer      : msestring;
  fcache        : string;
  ftracknum     : integer;
  fplaylist     : tstringlist;  (* simple playlist for files and online *)
  FChannelList  : TTVDataList;  (* analog TV Channel List *)
  fversion      : string;
  findexing     : boolean;
  
  (* output *)
  faudiooutput  : string;
  fvideooutput  : string;
  faudiooutputlist  : tstringlist; 
  fvideooutputlist  : tstringlist; 
  fvolume       : integer;
  
  flengthsec    : word;
  fpositionsec  : word;
    
//  fIsURL		: boolean;
  
  fcurrenttrack       : tCurrentTrackInfo;
  frepeatplaylist     : boolean;
  fShuffleplaylist    : boolean;
  fplaynexttrackallow : boolean; (* if user want play only one track *)
  falwaysCaching      : boolean; (* default false, means no caching local files *)
  
  fpausing      : boolean;
  fplaying      : boolean;
  fhavevideo    : boolean;
  
  (* video parameters *)
  fbrightness   : integer;
  fcontrast     : integer;
  fgamma        : integer;
  fhue          : integer;
  fsaturation   : integer;
  fbalance      : integer;
  
  (* events *)
  fonstartplay  : tStartPlayEvent;
  fstatus       : TStatusEvent; 
  fonendtrack   : TStatusEvent;
  fgetdebugmessage : TDebugMessageEvent;

  fonchangevolume  : TchangeVolumeEvent;

  FwriteOutToConsole : boolean; (* external, mean write output to console *)
  playnexttrack : boolean; (*internal flag for timer, meaning play next track *)
  fAddMplayerMessagesToDebug : boolean;
  ftvresolution : tvideoresolution;
  fmode         : tplaymode;
 protected
  procedure on_procfinished (const sender: TObject);
  procedure on_readterm     (const sender: TObject; var atext: AnsiString; const errorinput: Boolean);

  procedure on_timer        (const sender: tobject);
  procedure debug(line : string);
  function GetWindowId(disp : tcustomwindowwidget) : string;
  
  function checkplayer : boolean;
  function checktrack  : boolean;
//  function checkURL    : boolean;
  function checkURL    : tplaymode;
  procedure formatAudioOutputList;
  procedure formatVideoOutputList;

  procedure SetMode(const SMode:tplaymode);
    
 public
  constructor create(const aowner: tobject = nil);
  destructor  destroy; override;
  
  property version : string  read fversion;
  property pausing : boolean read fpausing;
  property playing : boolean read fplaying;

//  property isurl   : boolean read fIsUrl;

  property lengthsec       : word read flengthsec;
  property positionsec     : word read fpositionsec;
  property tracknum        : integer read ftracknum write ftracknum;
  property currenttrack    : tCurrentTrackInfo read fcurrenttrack;

  property indexing     : boolean read findexing write findexing;
  
  (* audio and video output *)
  property audiooutput  : string read faudiooutput write faudiooutput;
  property videooutput  : string read fvideooutput write fvideooutput;
  property audiooutputlist : tstringlist read faudiooutputlist;
  property videooutputlist : tstringlist read fvideooutputlist;

  (* mplayer management *)
  procedure play;
  procedure pause;
  procedure stop;
  procedure next;
  procedure prev;
  procedure setspeed(vol :integer);
  procedure GotoPosition(pos : integer);
  procedure SetVolume   (vol : integer);
  procedure SendCommandToMPlayer(cmd : string);

  (* video properties *)
  property brightness : integer read fbrightness;
  property contrast   : integer read fcontrast  ; 
  property gamma      : integer read fgamma     ;
  property hue        : integer read fhue       ;
  property saturation : integer read fsaturation;
  
  (* sound properties *)
  property balance    : integer read fbalance;
  property volume     : integer read fvolume;
  
  (* video properties management *)
  procedure setbrightness(vol : integer);
  procedure setcontrast(vol : integer);
  procedure setgamma(vol : integer);
  procedure sethue(vol : integer);
  procedure setsaturation(vol : integer);
  
  (* sound management *)
  procedure setBalance(vol : integer);  

  (* TV *)
  procedure OpenTV();
  procedure SetChannelByfreq(const Ch_freq:integer);
  procedure SetChannelByName(const Ch_name:TvCannelName);
  procedure SetChannelNorm(const __TVNorm:tvnorm);
  property tvresolution       : tvideoresolution   read ftvresolution;
    
 published (* need to be hided *)
  property mplayer            : msestring    		read fmplayer      write fmplayer;
  property cache              : string        		read fcache        write fcache;
  property display            : tcustomwindowwidget read fdisplay      write fdisplay;
  property havevideo          : boolean 			read fhavevideo    write fhavevideo;
  property Playlist           : tstringlist   		read fplaylist     write fplaylist;
  property RepeatPlaylist     : boolean read frepeatplaylist     write frepeatplaylist;
  property ShufflePlaylist    : boolean read fShuffleplaylist    write fShuffleplaylist;
  property PlayNextTrackAllow : boolean read fplaynexttrackallow write fplaynexttrackallow;
  property AlwaysCaching      : boolean read falwaysCaching      write falwaysCaching;
  property WriteOutToConsole  : boolean read fwriteOutToConsole  write fwriteOutToConsole;
  property AddMplayerMessagesToDebug : boolean read fAddMplayerMessagesToDebug  write fAddMplayerMessagesToDebug;
  property mode               : tplaymode      read fmode write fmode;
  property ListofChanell      : TTVDataList   read FChannelList  write FChannelList;
  
  (* events *)
  property onStartPlay    : tStartPlayEvent read fonStartPlay    write fonStartPlay;
  property Status         : TStatusEvent    read fStatus         write fStatus;
  property onEndTrack     : TStatusEvent    read fonEndTrack     write fonEndTrack;
  property onChangeVolume   : TchangeVolumeEvent read fonChangeVolume write fonChangeVolume;
  property onGetDebugMessage: TDebugMessageEvent read fgetdebugmessage write fgetdebugmessage;

 end; // tmplayer = ...

var 
  quotes : string;
  
implementation

//========================================================== 
//                TTVDataList class
//========================================================== 
function TTVDataList.AddItem(Item: TTVData): Integer;
var p: PTVData;
begin
  New(p);
  p^:=Item;
  Result := FTVList.Add(p); // просто перенаправляем вызов
end;

function TTVDataList.Count: integer;
begin
  Result := FTVList.Count; // просто перенаправляем вызов
end;

constructor TTVDataList.Create;
begin
  inherited Create;
  FTVList := TList.Create; // не забываем создать объект
end;

destructor TTVDataList.Destroy;
begin
  FTVList.Free; // уничтожаем объект
  inherited Destroy;
end;

procedure TTVDataList.Exchange(idx1, idx2: integer);
begin
  FTVList.Exchange(idx1, idx2); // просто перенаправляем вызов
end;

function TTVDataList.GetData(Idx: integer): TTVData;
begin
  FillChar(Result, SizeOf(TTVData), #0);
  Result :=TTVData(FTVList.Items[Idx]^); // перенаправляем вызов и приводим к TTVData
end;

procedure TTVDataList.SetData(IDx:integer;Data:TTvdata);
begin
  TTVData(FTVList.Items[Idx]^):=Data;
end;

procedure TTVDataList.RemoveItem(ItemIndex: Integer);
begin
  dispose(Ptvdata(FTVList[ItemIndex]));
  //FreeMem(FTVList[ItemIndex]); // освобождаем память тоже сами
  FTVList.Delete(ItemIndex);
end;


//========================================================== 
//                TMPLAYER CLASS
//========================================================== 
//========================================================== 
//                DEBUG OUT
//========================================================== 
procedure tmplayer.debug(line : AnsiString);
begin
 if FwriteOutToConsole then writeln(line);
 if assigned(fgetdebugmessage) then fgetdebugmessage(self, line); 
end;

//========================================================== 
//                CREATE
//========================================================== 
constructor tmplayer.create(const aowner: tobject);
begin
 fversion :=  '0.8.5';

 fterm := tterminal.create(nil);

 {$ifdef mswindows}
 fterm.optionsprocess := fterm.optionsprocess + [pro_inactive]; // pro_inactive hide cmd.exe window in mswindows
 {$endif}
 
 fterm.onprocfinished := @on_procfinished;
 fterm.onreceivetext  := @on_readterm;
 
 ftimer := ttimer.create(nil);
 ftimer.ontimer := @on_timer;
 ftimer.interval := 500000;
 ftimer.enabled := true;

 fplaylist := tstringlist.create;
 FChannelList:= TTVDataList.Create; 

 faudiooutputlist := tstringlist.create;
 fvideooutputlist := tstringlist.create;
 FormatAudioOutputList;
 FormatVideoOutputList;
  
 fdisplay := tcustomwindowwidget.create(nil);
 
 fAddMplayerMessagesToDebug := false;
 
 {$ifdef mswindows}
 fmplayer := 'c:\program files\mplayer for windows\mplayer.exe';
 fwriteOutToConsole := false;
 quotes := '';//'"';
 {$endif}
 
 {$ifdef linux}
 fmplayer := '/usr/bin/mplayer';
 fwriteOutToConsole := true;
 quotes := '';
 {$endif}
 
 fplaynexttrackallow := true;
 frepeatplaylist  := false;
 fShuffleplaylist := false;
 falwaysCaching := false;
 fplaying := false;
 fpausing := false;
 
 fcache := '1024';
 fvolume := 50;
 fpositionsec := 0;
 flengthsec := 0;  
 ftrackNum := 0;
 fbrightness := 0;
 fcontrast := 0;
 
 faudiooutput := 'default';
 fvideooutput := 'default';
end;

//========================================================== 
//                DESTROY
//========================================================== 
destructor tmplayer.destroy;
begin
 stop;
 debug('*** Exit alsmplayer. Bye!');
 fterm.free;
 ftimer.free;
 fplaylist.free;
 fdisplay.free;
 inherited destroy;
end;

//========================================================== 
//                format audio output string list
//==========================================================
procedure tmplayer.FormatAudioOutputList;
begin
 faudiooutputlist.add('default');   faudiooutputlist.add('alsa');   
 faudiooutputlist.add('alsa5');     faudiooutputlist.add('oss');   
 faudiooutputlist.add('sdl');       faudiooutputlist.add('arts'); 
 faudiooutputlist.add('esd');       faudiooutputlist.add('jack');   
 faudiooutputlist.add('nas');       faudiooutputlist.add('coreaudio');
 faudiooutputlist.add('openal');    faudiooutputlist.add('pulse');   
 faudiooutputlist.add('sgi');       faudiooutputlist.add('sun');    
 faudiooutputlist.add('win32'); 	faudiooutputlist.add('dsound');  
 faudiooutputlist.add('dart');      faudiooutputlist.add('dxr2');   
 faudiooutputlist.add('ivtv');      faudiooutputlist.add('v4l2');    
 faudiooutputlist.add('mpegpes'); 
end;

//========================================================== 
//                format video output string list
//==========================================================
procedure tmplayer.FormatVideoOutputList;
begin
 fvideooutputlist.add('default');   fvideooutputlist.add('x11');
 fvideooutputlist.add('xover');     fvideooutputlist.add('vdpau');
 fvideooutputlist.add('xvmc');      fvideooutputlist.add('dga');
 fvideooutputlist.add('sdl');       fvideooutputlist.add('vidix');
 fvideooutputlist.add('xvidix');    fvideooutputlist.add('cvidix');
 fvideooutputlist.add('winvidix');  fvideooutputlist.add('direct3d');
 fvideooutputlist.add('directx');   fvideooutputlist.add('kva');
 fvideooutputlist.add('quartz');    fvideooutputlist.add('corevideo');
 fvideooutputlist.add('fbdev');     fvideooutputlist.add('fbdev2');
 fvideooutputlist.add('vesa');      fvideooutputlist.add('svga');
 fvideooutputlist.add('gl');        fvideooutputlist.add('gl2');
 fvideooutputlist.add('aa');        fvideooutputlist.add('caca');
 fvideooutputlist.add('bl');        fvideooutputlist.add('ggi');
 fvideooutputlist.add('directfb');  fvideooutputlist.add('dfbmga');
 fvideooutputlist.add('mga');       fvideooutputlist.add('xmga');
 fvideooutputlist.add('s3fb');      fvideooutputlist.add('wii');
 fvideooutputlist.add('3dfx');      fvideooutputlist.add('tdfxfb');
 fvideooutputlist.add('tdfx_vid');  fvideooutputlist.add('dxr2');
 fvideooutputlist.add('dxr3');      fvideooutputlist.add('ivtv');
 fvideooutputlist.add('v4l2');      fvideooutputlist.add('mpegpes');
 fvideooutputlist.add('zr');        fvideooutputlist.add('zr2');
 fvideooutputlist.add('yuv4mpeg');  fvideooutputlist.add('gif89a');
 fvideooutputlist.add('jpeg');      fvideooutputlist.add('pnm');
 fvideooutputlist.add('png');       fvideooutputlist.add('tga');
 fvideooutputlist.add('null');
end;

//==========================================================
//          Set Mode  TV,DVB,...
//==========================================================
procedure tmplayer.SetMode(const SMode: tplaymode);
begin
 ftimer.enabled:=false;
 if fmode=SMode 
    then begin end 
    else begin
		  stop;
         end;
 fTimer.enabled:=True;
end;

//==========================================================
//          Open TV
//==========================================================
procedure tmplayer.OpenTV();
var     cmd : string;
        wID : string;
begin
 debug('========================================================');
 debug('ALSMPLAYER VERSION ' + fversion);
 debug('NOTE: strings with <***> is output of alsmmplayer class,');
 debug('      without is output of mplayer');
 debug('========================================================');
 debug('*** OpenTV : Start');
 if not checkplayer then exit;
 stop;
 ftimer.Enabled:=False;
 
 fmode:=__tv;
 if assigned(fStatus) then fStatus(self,'Connecting to TV ...', 0, 0);
 wID := GetWindowId(fdisplay);
 if wID <> '' then wID := ' -wid ' + wID;
 cmd := fmplayer+ ' tv:// -slave -quiet'+ wID+ ' driver=v4l2';
 fterm.execprog(cmd);
 debug('*** Open TV:' + cmd);
end;

//========================================================== 
//                check if mplayer is exists
//========================================================== 
function tmplayer.checkplayer : boolean;
begin
 if fileexists(fmplayer) 
 and (extractfilename(fmplayer) = 
    {$ifdef mswindows}'mplayer.exe'{$endif}
    {$ifdef linux}'mplayer'{$endif} )
    then begin
          result := true;
          debug('*** CHECK PLAYER: mplayer found : ' + fmplayer);
        end
   else begin 
          result := false;
          debug('*** CHECK PLAYER: mplayer not found');
        end;
end;

//========================================================== 
//                check if current track is exists
//========================================================== 
function tmplayer.checktrack : boolean;
begin
 if fileexists(fplaylist[ftrackNum]) 
   then begin 
         result := true;
         debug('*** CHECK TRACK: truckNum ' + inttostr(ftrackNum) + ' (' + fplaylist[ftrackNum] + ') found');
        end
   else begin 
         result := false;
         debug('*** CHECK TRACK: truckNum ' + inttostr(ftrackNum) + ' (' + fplaylist[ftrackNum] + ') not found');
        end;
end;

//========================================================== 
//                check if current track is URL - dummy ...
//========================================================== 
function tmplayer.checkurl : tplaymode;
var s : string;
begin
 fmode := __file; 
 if fplaylist.count = 0 
   then begin 
          debug('*** CHECKURL: Nothing to play! Playlist is empty');
          if assigned(fStatus) then fStatus(self,'Playlist is empty!', 0, 0);          
          exit;
        end;
 s := fplaylist[ftrackNum];
 if (pos('mms://'  , s) > 0) or
    (pos('http://' , s) > 0) or
    (pos('rtsp://' , s) > 0) then fmode := __inet;
 if (pos('tv://' , s) > 0)  then fmode := __tv;
 (* add cdrom, dvdrom, etc ... *)

 result := fmode;
 case fmode of
 __inet : debug('*** CHECKURL: source is internet source');
 __file : debug('*** CHECKURL: source is local file');
 __tv   : debug('*** CHECKURL: source is TV-tuner');
 end;
end;

//========================================================== 
//                TMPLAYER EVENTS
//========================================================== 
//========================================================== 
//       on finished terminal work (track is finished)
//========================================================== 
procedure tmplayer.on_procfinished(const sender: TObject);
begin
 debug('*** END OF TRACK');
 if assigned(fonEndTrack) then fonEndTrack(self, 'End of track', fpositionsec, flengthsec); 
 if fplaying then playnexttrack := true; (* this is internal flag for ontimer event, not procedure! *)
end; 

//========================================================== 
//                read output
//========================================================== 
procedure tmplayer.on_readterm(const sender: TObject; var atext: AnsiString; const errorinput: Boolean);
Var txt, S : msestring;               
begin
 txt  := atext;   (* output text may contain all infarmation at one time *)
 if fAddMplayerMessagesToDebug then debug(trim(txt));
 
case fmode of
__file, __inet:
begin  
 (* on start playing moment *)
 if (not fpausing) and (not fplaying) and (pos('Starting playback',txt) > 0)  then
   begin
     debug('*** TIMER: Starting playback');  
     debug('*** TIMER: try to get video resolution ...');
     fterm.writestrln('get_video_resolution');
   end;
      
 if pos('ANS_VIDEO_RESOLUTION=', txt) > 0  then
   begin
    s := txt;
    delete(s,1,length('ANS_VIDEO_RESOLUTION=''') + pos('ANS_VIDEO_RESOLUTION=''',s) - 1 );
    delete(s,pos('''',s),length(s) - pos('''',s) - 1 );

    if trim(s) <> '' 
        then begin
               fcurrenttrack.videoresolution.x := strtoint(trim(copy(s,1,pos('x',s) - 1)));
               delete(s,1,pos('x',s));
               fcurrenttrack.videoresolution.y := strtoint(trim(s));
               fhavevideo := true;
             end   
        else begin 
               fcurrenttrack.videoresolution.x := 0;
               fcurrenttrack.videoresolution.y := 0;
               fhavevideo := false;
             end;  
    debug('*** TIMER: video resolution : ' 
             + inttostr(fcurrenttrack.videoresolution.x) + ' x ' 
             + inttostr(fcurrenttrack.videoresolution.y) );
    fplaying := true;
    if assigned(fonstartplay) then fonstartplay(self, fcurrenttrack.videoresolution.x, fcurrenttrack.videoresolution.y, fvolume);
    if assigned(fonchangevolume) then fonchangevolume(self, fvolume);
   end;   

 (* Connecting to server *)
 if (not fpausing) and (not fplaying) and (pos('Connecting to server', txt) > 0)  then
   begin
     debug('*** TIMER: Connecting to server ...');  
     if assigned(fStatus) then fStatus(self, 'Connecting to server ...', 0, 0);
   end;

 (* Connected *)
 if (not fpausing) and (not fplaying) and (pos('Connected', txt) > 0)  then
   begin
     debug('*** TIMER: Connected');  
     if assigned(fStatus) then fStatus(self, 'Connected', 0, 0);
   end;

 (*  Generated index table *)
 if (pos('Generated index table', txt) > 0)  then
   begin
     debug('*** TIMER: Generated index table');  
     if assigned(fStatus) then fStatus(self, 'Generated index table', 0, 0);
   end;

 (* Video stream found *)
 if (pos('Video stream found', txt) > 0)  then
   begin
     debug('*** TIMER: Video stream found');  
     if assigned(fStatus) then fStatus(self, 'Video stream found', 0, 0);
   end;
   
 (* Audio stream found *)
 if (pos('Audio stream found', txt) > 0)  then
   begin
     debug('*** TIMER: Audio stream found');  
     if assigned(fStatus) then fStatus(self, 'Audio stream found', 0, 0);
   end;

 (* Audio only file format detected *)
 if (pos('Audio only file format detected', txt) > 0)  then
   begin
     debug('*** TIMER: Audio only file format detected');  
     if assigned(fStatus) then fStatus(self, 'Audio only file format detected', 0, 0);
   end;

 (* Incomplete stream? Trying resync. *)
 if (pos('Incomplete stream? Trying resync.', txt) > 0)  then
   begin
     debug('*** TIMER: Incomplete stream? Trying resync.');  
     if assigned(fStatus) then fStatus(self, 'Incomplete stream? Trying resync.', 0, 0);
   end;


 (* Cache fill *)
 if (not fpausing) and (not fplaying) and (pos('Cache fill:', txt) > 0)  then
   begin
     s := txt;
     delete(s,1,pos(':',s));
     debug('*** TIMER: ' + 'Cache fill:' + s);  
     if assigned(fStatus) then fStatus(self, 'Cache fill:' + s, 0, 0);
   end;

 (* Cache not filling *)
 if (not fpausing) and (fplaying) and (pos('Cache not filling', txt) > 0)  then
    begin
      debug('*** TIMER: Cache not filling!!!');  
      if assigned(fStatus) then fStatus(self, 'Cache not filling', 0, 0);
    end;

 (* curent track total length in seconds *)
 if pos('ANS_LENGTH=', txt) > 0  then
    begin
      s := txt;
      delete( s,1,length('ANS_LENGTH=') + pos('ANS_LENGTH=',s) - 1);
      delete( s,pos('.',s),length(s) - pos('.',s) - 1 );
      flengthsec := strtoint(trim(s));
    end;
    
 (* current position in curent track in seconds *)
 if pos('ANS_TIME_POSITION=', txt) > 0  then
    begin
      s := txt;
      delete( s,1,length('ANS_TIME_POSITION=') + pos('ANS_TIME_POSITION=',s) - 1);
      delete( s,pos('.',s),length(s) - pos('.',s) - 1 );
      fpositionsec := strtoint(trim(s));
    end;
end;
__tv:
 begin;
  {if pos('ANS_height=',txt)> 0 then
   begin
    S:=txt;
    delete(s,1,length('ANS_height=')+pos('ANS_height=',s)-1);
    ftvresolution.x:=strtoint(trim(s));
   end;
  if pos('ANS_width=',txt)> 0 then
   begin
    S:=txt;
    delete(s,1,length('ANS_width=')+pos('ANS_width=',s)-1);
    ftvresolution.y:=strtoint(trim(s));
   end;}
 end;
end; // case fmode ...    
end;

//========================================================== 
//         TIMER :  send length and position request
//========================================================== 
procedure tmplayer.on_timer(const sender : tobject);
begin
if fmode=__file then
begin
 if playnexttrack then 
 begin
   playnexttrack := false;
   next;						(* here is play next track procedure ! *)
 end;

 if fplaying then
   begin
    if fpausing 
       then begin  (* THIS BEGIN IS NEEDED, DON`T DELETE IT, STUPID! *)
              if assigned(fStatus) then fStatus(self, 'Pause', fpositionsec, flengthsec);
            end
       else begin
			  fterm.writestrln('get_time_pos');    
			  fterm.writestrln('get_time_length');
              if assigned(fStatus) then fStatus(self, 'Play', fpositionsec, flengthsec);
            end;
   end;
end;

if fmode=__tv then
begin
  //fterm.writestrln('get_property width');
  //fterm.writestrln('get_property height');
 //v4l2: ioctl streamon failed: Device or resource busy
end;
   
end;

//========================================================== 
//                MPLAYER MANAGEMENT
//========================================================== 
//========================================================== 
//                get Window Id
//========================================================== 
function tmplayer.getWindowId(disp : tcustomwindowwidget) : string;
begin
 try result := inttostr(disp.clientwinid);
 except result := '';
 end;
end;

//========================================================== 
//                play
//========================================================== 
procedure tmplayer.play;
var     cmd : string;
     vo, ao : string;
       indx : string;
       cach : string; 
        wID : string; 
begin
 debug('========================================================');
 debug('ALSMPLAYER VERSION ' + fversion);
 debug('NOTE: strings with <***> is output of alsmmplayer class,');
 debug('      without is output of mplayer');
 debug('========================================================');
 debug('*** PLAY : Start');

 if not checkplayer then exit;

 case checkUrl of 
 __tv : begin 
          OpenTV(); 
          exit;
        end;
        
 __inet, __file:
 begin
 if ftracknum < 0 then 
           begin
             debug('*** PLAY : Autocorrect Track Number from "' + inttostr(ftracknum) + '" to "0"');
             ftracknum := 0;
           end;  
           
 if ftracknum > fplaylist.count - 1 then
           begin
             debug('*** PLAY : Autocorrect Track Number from "' + inttostr(ftracknum) + '" to "' + inttostr(fplaylist.count - 1) + '"');
             ftracknum := fplaylist.count - 1;
           end; 
         
 if fmode = __file then
 if not checktrack then (* if broken track then next ! *)
		      begin 
		   		next;    
		  		exit;
		  	  end;
        
 debug('*** PLAY: stoping if need ...');
 stop;

   if assigned(fStatus) then fStatus(self,'Connecting ...', 0, 0); 
   
   if fvideooutputlist.indexof(fvideooutput) < 0 
        then begin
              debug('*** PLAY: unknown video output ' + fvideooutput + ', set to "default"');
              fvideooutput := 'default';
             end; 

   if (fvideooutput = 'default') or (fvideooutput = '') 
        then vo := ''
        else vo := ' -vo ' + fvideooutput;
        
        
   if faudiooutputlist.indexof(faudiooutput) < 0 
        then begin
              debug('*** PLAY: unknown audio output ' + faudiooutput + ', set to "default"');
              faudiooutput := 'default';
             end; 
          
   if (faudiooutput = 'default') or (faudiooutput = '') 
        then ao := ''
        else ao := ' - ao ' + faudiooutput;
   
   
   if findexing then indx := ' -idx' else indx := '';
   
   if (falwaysCaching) or (fmode = __inet)
       then cach := ' -cache ' + fcache
       else cach := '';
   
   wID := GetWindowId(fdisplay);
   if wID <> '' then wID := ' -wid ' + wID;
   
   cmd := quotes + fmplayer + quotes
                      + ' -slave -softvol -quiet'
                      + vo 
                      + ao 
      		    	  + cach
      		    	  + ' -volume ' + inttostr(fvolume)
      		    	  + wID
      		    	  + indx
    			      + ' "'  + fplaylist[ftracknum]  + '"';
    			      
   fterm.execprog(cmd);
   debug('*** PLAY: ' + cmd);

   fpositionsec := 0;
   flengthsec   := 0;
   fcurrenttrack.filename := fplaylist[ftracknum];
  end; 
 end; // case checkurl ...  
end;

//========================================================== 
//                pause
//========================================================== 
procedure tmplayer.pause;
begin
 if fterm.running then 
    begin 
      fterm.writestrln('pause');
	  fpausing := not fpausing;
	  IF Fpausing then  debug('*** PAUSE: on');
	  IF not Fpausing then  debug('*** PAUSE: off');
      if assigned(fStatus) then fStatus(self, 'Pausing', fpositionsec, flengthsec); //dummy
    end;
end;

//========================================================== 
//                stop
//========================================================== 
procedure tmplayer.stop;
begin
 fpausing  := false;
 fplaying  := false;
 if fterm.running then
    begin
      debug('*** STOP');
      fterm.writestrln('quit');
      fterm.waitforprocess();
      application.processmessages;
      if fterm.running then 
        begin
          debug('*** STOP: send kill signal');
          fterm.killprocess;
          if fterm.running then debug('*** STOP: can`t stop process, maybe zomby');
        end;
    end;
end;

//========================================================== 
//                PLAYLIST MANAGEMENT
//========================================================== 
//========================================================== 
//                next
//========================================================== 
procedure tmplayer.next;
begin
 if not fplaynexttrackallow 
   then begin
          debug('*** NEXT: Automatic play next track not allowed');
          exit;
        end;
        
 if fShuffleplaylist 
   then begin
          ftrackNum := random(fplaylist.count);
          debug('*** NEXT: Shuffle is ON. Next track is ' + inttostr(ftrackNum));
          play;
          exit;
        end;       
        
 if ftrackNum < fplaylist.count - 1
   then begin
          inc(ftrackNum);
          debug('*** NEXT: Shuffle is OFF. Next track is ' + inttostr(ftrackNum));
          play;
        end 
   else begin
          debug('*** NEXT: End of playlist');
          if assigned(fStatus) then fStatus(self, 'End of playlist', fpositionsec, flengthsec);
          if not frepeatplaylist 
             then begin
                    debug('*** NEXT: Repeat playlist not allowed');
                    stop;
                  end
             else begin
                    ftrackNum := 0;
 		            debug('*** NEXT: Repeat playlist. Shuffle is OFF. Next track is ' + inttostr(ftrackNum));
                    play;
                  end; 
         end;
end;

//========================================================== 
//                prev
//========================================================== 
procedure tmplayer.prev;
begin
 if fShuffleplaylist 
   then begin
          ftrackNum := random(fplaylist.count);
          debug('*** PREV: Shuffle is ON. Next track is ' + inttostr(ftrackNum));
          play;
          exit;
        end; 
        
 if ftrackNum > 0
      then begin 
             dec(ftrackNum);
             debug('*** PREV: Prev track is ' + inttostr(ftrackNum));            
             play;
           end
      else debug('*** PREV: Already on first track');
end;

//========================================================== 
//                SPEED MANAGEMENT
//========================================================== 
//========================================================== 
//                set speed
//========================================================== 
procedure tmplayer.setspeed(vol : integer);
begin
 if fterm.running and not fpausing then
    fterm.writestrln('speed_set ' + inttostr(vol));

 debug('*** SPEED: ' + inttostr(vol));
end;

//========================================================== 
//                VOLUME MANAGEMENT
//========================================================== 
//========================================================== 
//                set volume
//========================================================== 
procedure tmplayer.setvolume(vol : integer);
begin
 if vol < 0 then 
      begin
        debug('*** VOLUME: Autocorrect volume from "' + inttostr(vol) + '" to "0"');
        vol := 0;
      end; 
   
 if vol > 100 then 
      begin
        debug('*** VOLUME: Autocorrect volume from "' + inttostr(vol) + '" to "100"');
        vol := flengthsec;
      end; 

 if fterm.running and not fpausing then
    fterm.writestrln('volume ' + inttostr(vol) + ' 1');
  
 fvolume := vol;
 debug('*** VOLUME: ' + inttostr(fvolume));
 if assigned(fonchangevolume) then fonchangevolume(self, fvolume);
end;

//========================================================== 
//                tv chanels management
//========================================================== 
procedure tmplayer.SetChannelByfreq(const Ch_freq: integer);
begin
if fterm.running then
 begin
  fterm.writestrln('tv_set_freq ' + IntToStr(Ch_freq));
 end;
end;

procedure tmplayer.SetChannelByName(const Ch_name: TvCannelName);
begin
if fterm.running then
 begin
  fterm.writestrln('tv_set_channel ' + tvCannelNameStr[Ch_name]);
 end;
end;

procedure tmplayer.SetChannelNorm(const __TVNorm: tvnorm);
begin
if fterm.running then
 begin
  fterm.writestrln('tv_set_norm ' + TvStr[__TVNorm]);
 end;
end;

//========================================================== 
//                POSITIONS MANAGEMENT
//========================================================== 
//========================================================== 
//                set position
//========================================================== 
procedure tmplayer.gotoposition(pos : integer);
begin
 ftimer.enabled := false;
 if fterm.running then
  begin
   if pos < 0 then 
      begin
        debug('*** SETPOSITION: Autocorrect position from "' + inttostr(pos) + '" to "0"');
        pos := 0;
      end; 
   
   if pos > flengthsec then 
      begin
        debug('*** SETPOSITION: Autocorrect position from "' + inttostr(pos) + '" to "'+ inttostr(flengthsec) + '"');
        pos := flengthsec;
      end; 
   
   fterm.writestrln('seek ' + inttostr(pos) + ' 2');
   fpositionsec := pos;
   debug('*** SETPOSITION: ' + inttostr(fpositionsec));
  end;
 ftimer.enabled := true;
end;

//========================================================== 
//                VIDEO MANAGEMENT
//========================================================== 
//========================================================== 
//                brightness
//========================================================== 
procedure tmplayer.setbrightness(vol : integer);
begin
 if fterm.running then
  begin
   if vol < -100 then 
      begin
        debug('*** BRIGHTNESS: Autocorrect brightness from "' + inttostr(vol) + '" to "-100"');
        vol := -100;
      end; 
   
   if vol > 100 then 
      begin
        debug('*** BRIGHTNESS: Autocorrect brightness from "' + inttostr(vol) + '" to "100"');
        vol := 100;
      end; 
   
   fterm.writestrln('brightness ' + inttostr(vol) + ' 1');
   fbrightness := vol;
   debug('*** BRIGHTNESS: ' + inttostr(fbrightness));
  end;
end;

//========================================================== 
//                contrast
//========================================================== 
procedure tmplayer.setcontrast(vol : integer);
begin
 if fterm.running then
  begin
   if vol < -100 then 
      begin
        debug('*** CONTRAST: Autocorrect contrast from "' + inttostr(vol) + '" to "-100"');
        vol := -100;
      end; 
   
   if vol > 100 then 
      begin
        debug('*** CONTRAST: Autocorrect contrast from "' + inttostr(vol) + '" to "100"');
        vol := 100;
      end; 
   
   fterm.writestrln('contrast ' + inttostr(vol) + ' 1');
   fbrightness := vol;
   debug('*** CONTRAST: ' + inttostr(fbrightness));
  end;
end;

//========================================================== 
//                gamma
//========================================================== 
procedure tmplayer.setgamma(vol : integer);
begin
 if fterm.running then
  begin
   if vol < -100 then 
      begin
        debug('*** GAMMA: Autocorrect gamma from "' + inttostr(vol) + '" to "-100"');
        vol := -100;
      end; 
   
   if vol > 100 then 
      begin
        debug('*** GAMMA: Autocorrect gamma from "' + inttostr(vol) + '" to "100"');
        vol := 100;
      end; 
   
   fterm.writestrln('gamma ' + inttostr(vol) + ' 1');
   fgamma := vol;
   debug('*** GAMMA: ' + inttostr(fgamma));
  end;
end;

//========================================================== 
//                hue
//========================================================== 
procedure tmplayer.sethue(vol : integer);
begin
 if fterm.running then
  begin
   if vol < -100 then 
      begin
        debug('*** HUE: Autocorrect hue from "' + inttostr(vol) + '" to "-100"');
        vol := -100;
      end; 
   
   if vol > 100 then 
      begin
        debug('*** HUE: Autocorrect hue from "' + inttostr(vol) + '" to "100"');
        vol := 100;
      end; 
   
   fterm.writestrln('hue ' + inttostr(vol) + ' 1');
   fhue := vol;
   debug('*** HUE: ' + inttostr(fhue));
  end;
end;

//========================================================== 
//                saturation
//========================================================== 
procedure tmplayer.setsaturation(vol : integer);
begin
 if fterm.running then
  begin
   if vol < -100 then 
      begin
        debug('*** SATURATION: Autocorrect saturation from "' + inttostr(vol) + '" to "-100"');
        vol := -100;
      end; 
   
   if vol > 100 then 
      begin
        debug('*** SATURATION: Autocorrect saturation from "' + inttostr(vol) + '" to "100"');
        vol := 100;
      end; 
   
   fterm.writestrln('saturation ' + inttostr(vol) + ' 1');
   fsaturation := vol;
   debug('*** SATURATION: ' + inttostr(fsaturation));
  end;
end;

//========================================================== 
//                SOUND MANAGEMENT
//========================================================== 
//========================================================== 
//                balance
//========================================================== 
procedure tmplayer.setBalance(vol : integer);
begin
 if fterm.running then
  begin
   if vol < -100 then 
      begin
        debug('*** BALANCE: Autocorrect balance from "' + inttostr(vol) + '" to "-100"');
        vol := -100;
      end; 
   
   if vol > 100 then 
      begin
        debug('*** BALANCE: Autocorrect balance from "' + inttostr(vol) + '" to "100"');
        vol := 100;
      end; 
   
   fterm.writestrln('balance ' + inttostr(vol) + ' 1');
   fbalance := vol;
   debug('*** BALANCE: ' + inttostr(fbalance));
  end;
end;

//========================================================== 
//                SEND OWN COMMAND TO MPLAYER
//========================================================== 
procedure tmplayer.SendCommandToMPlayer(cmd : string);
begin
 if fterm.running then
   begin
     fterm.writestrln(cmd); 
     debug('*** SENDING USER COMMAND TO MPLAYER :' + cmd);
   end;
end;

end.
// revision 01/12/2010 - 1000 strings
// revision 18/11/2010 - 818 strings
// revision 18/10/2010 - 881 strings
// revision 13/10/2010 - 691 strings
// revision 14/09/2010 - 685 strings 
// revision 29/09/2010 - 1038 strings 
