unit playlists;

{$ifdef FPC}{$mode objfpc}{$h+}{$endif}
interface
uses classes, sysutils, functions;

procedure openasx_playlist(fname : string; var sl : tstringlist);
procedure openpls_playlist(fname : string; var sl : tstringlist);
procedure openkpl_playlist(fname : string; var sl : tstringlist);
procedure openm3u_playlist(fname : string; var sl : tstringlist);
 
 
implementation

var
   separator : char = {$ifdef mswindows}'\'{$endif}{$ifdef linux}'/'{$endif};
// ======================================================= 
// 				 open PLS playlist (totem, mplayer, etc)
// ======================================================= 
procedure openpls_playlist(fname : string; var sl : tstringlist);
var f : textfile;
    s : string;
begin
  sl.clear;

  {$ifdef mswindows}
  if fname[1] = '/' then delete(fname,1,1);
  {$endif}  
 if not fileexists(fname) then exit;

 assignfile(f, fname);
 reset(f);
 while not eof(f) do 
  begin
    readln(f,s);
    if substrpos('File',s) = 1 then 
      begin
        delete(s,1,substrpos('=',s));
        
		if extractfilepath(s) = '' then s := extractfilepath(fname) + separator + s;
		sl.add(s);
      end;
  end;
 closefile(f);
end;

// ======================================================= 
// 				 open kpl playlist (kmplayer)
// ======================================================= 
procedure openkpl_playlist(fname : string; var sl : tstringlist);
var f : textfile;
    s : string;
    s2 : string;
begin
// showmessage('This type of playlist not supported in now');
end;

// ======================================================= 
//          Load .m3u Playlist (winamp player)
// =======================================================        
procedure openm3u_playlist(fname : string; var sl : tstringlist);
var f : textfile;
    s : string;
begin
  sl.clear;


  {$ifdef mswindows}
  if fname[1] = '/' then delete(fname,1,1);
  {$endif}  
 if not fileexists(fname) then 
   begin
     exit;
   end;
 assignfile(f, fname);
 reset(f);
 while not eof(f) do 
  begin
    readln(f,s);
    if substrpos('#',s) > 0 then continue;

	if extractfilepath(s) = '' then s := extractfilepath(fname) + separator + s;
	sl.add(s);
  end;
 closefile(f);
end;

// ======================================================= 
//          Load .asx Playlist 
// =======================================================        
procedure openasx_playlist(fname : string; var sl : tstringlist);
var f : textfile;
    s : string;
begin
  sl.clear;

 {$ifdef mswindows}
 if fname[1] = '/' then delete(fname,1,1);
 {$endif}  
 if not fileexists(fname) then 
   begin
     exit;
   end;
   
 assignfile(f, fname);
 reset(f);
 while not eof(f) do 
  begin
    readln(f,s);
    if substrpos('<Ref href',s) > 0 then 
      begin
        delete(s,1,substrpos('"',s));
        
        s := copy(s,1,substrpos('"',s) - 1);
        
		if extractfilepath(s) = '' then s := extractfilepath(fname) + separator + s;
		sl.add(s);
      end;
  end;
 closefile(f);
end;

end.
